"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.indexOfArray = exports.proxyGet = exports.isPromise = void 0;
function isPromise(test) {
    return !!test && typeof test.then === "function";
}
exports.isPromise = isPromise;
function proxyGet(obj, transform) {
    return new Proxy(obj, {
        get: function (obj, name) {
            return transform(obj[name], name);
        },
    });
}
exports.proxyGet = proxyGet;
function indexOfArray(source, search) {
    var run = true;
    var start = 0;
    while (run) {
        var idx = source.indexOf(search[0], start);
        // not found
        if (idx < start) {
            run = false;
            continue;
        }
        // Make sure the rest of the subarray contains the search pattern
        var subBuff = source.subarray(idx, idx + search.length);
        var retry = false;
        var i = 1;
        for (; i < search.length && !retry; ++i) {
            if (subBuff[i] !== search[i]) {
                retry = true;
            }
        }
        if (retry) {
            start = idx + i;
            continue;
        }
        else {
            return idx;
        }
    }
    return -1;
}
exports.indexOfArray = indexOfArray;
//# sourceMappingURL=utils.js.map